export function checkStringLength(str) {
  const pattern = new RegExp('[\u4E00-\u9FA5]+')
  return pattern.test(str) ? 10 : 12
}
import lodash from 'lodash'
export function formatterText(value, isforMatX = false, cutLabelLength = 0) {
  const maxTextLength =
    lodash.isNumber(cutLabelLength) && cutLabelLength > 0
      ? cutLabelLength
      : checkStringLength(value)
  let textList = value.split('').slice(0, maxTextLength)
  if (value.length >= maxTextLength) {
    textList.push('...')
  }
  if (isforMatX) {
    return textList.join('\n')
  }
  return textList.join('')
}

export function isOverLength(
  id,
  length,
  type = 'height',
  gap = 0,
  option = {}
) {
  let scaleX = 1,
    scaleY = 1
  if (option?.scaleEl) {
    const scaleEl = document.querySelector(option.scaleEl)
    const transformMatrix = window
      .getComputedStyle(scaleEl)
      .getPropertyValue('transform')
    const matrixValues = transformMatrix
      .match(/matrix\(([^)]+)\)/)[1]
      .split(', ')
    scaleX = parseFloat(matrixValues[0])
    scaleY = parseFloat(matrixValues[3])
  }

  const el = document.querySelector(`#${id}`)
  const typeCur = type === 'width' ? 'clientWidth' : 'clientHeight'
  const scale = type === 'width' ? scaleX : scaleY
  let gapCur = gap ? gap : type === 'width' ? 30 : 20
  if (option?.extraData?.isforMatX) {
    gapCur = 20
  }
  if (!el) return false
  let size = el[typeCur] * scale

  if (!size || Number.isNaN(size)) return false
  return size / length < gapCur
}
