export function chartProcessData(
  arr,
  xField = 'name',
  yValue = 'value',
  isSort = false,
  desc = true
) {
  if (isSort) {
    arr = arr.sort((x, y) => {
      return desc ? y[yValue] - x[yValue] : x[yValue] - y[yValue]
    })
  }
  const x = [...new Set(arr.map((item) => item[xField]))]
  const ydata = []
  arr.map((item) => {
    const itemValue =
      typeof item[yValue] === 'number' && item[yValue] % 1 === 0
        ? item[yValue]
        : +item[yValue].toFixed(2)
    ydata.push(itemValue)
  })
  return {
    xdata: x,
    ydata
  }
}

export function chartProcessDataCategory(
  arr,
  xField = 'name',
  yField = 'category',
  yValue = 'value',
  isSort = false,
  desc = true,
  option = { showTotal: false }
) {
  const x = [...new Set(arr.map((item) => item[xField]))]
  const category = [...new Set(arr.map((item) => item[yField]))].sort()
  const yObj = {}
  let xSort = x || []
  const total = []

  if (isSort) {
    const xTotal = []
    xSort = []
    x.map((xName) => {
      const item = {}
      const val = arr
        .filter((item) => item[xField] === xName)
        .reduce((x, y) => {
          return (x += y[yValue])
        }, 0)
      item[xField] = xName
      item[yValue] = val
      xTotal.push(item)
    })

    xSort = xTotal
      .sort((x, y) => {
        return desc ? y[yValue] - x[yValue] : x[yValue] - y[yValue]
      })
      .map((item) => item[xField])
  }
  arr.map((item) => {
    if (!yObj[item[yField]]) {
      yObj[item[yField]] = new Array(xSort.length).fill(0)
    }
    const xIndex = xSort.findIndex((xCase) => xCase === item[xField])
    yObj[item[yField]][xIndex] =
      typeof item[yValue] === 'number' && item[yValue] % 1 === 0
        ? item[yValue]
        : +item[yValue].toFixed(2)
    if (!total[xIndex]) total[xIndex] = 0
    total[xIndex] += item[yValue]
  })
  const res = {
    xdata: isSort ? xSort : x,
    category,
    yObj
  }
  if (option?.showTotal) {
    res.total = total
  }
  return res
}

export function getXdataByBgColor(itemIndex) {
  return xdata.map((item, index) => {
    return `rgba(180, 180, 180,${itemIndex === index ? 0.3 : 0})`
  })
}
