import formGenRender from '@/views/element-form-Render/formGenRender.vue'

import formGenParser from '@/components/parser/Parser.vue'
import formGenParserItemList from '@/components/parser/ParseItemList.vue'
import myTree from '@/components/myTree/index.vue'
import richEditor from '@/views/element-item/richEditor/index.vue'
import richTextRender from '@/views/element-item/richTextRender'
import searchSelectTag from '@/views/element-item/searchSelectTag'
import sidebarRouteCom from '@/views/element-item/sidebarRouteCom'
import nodeTree from '@/views/element-item/nodeTree'
import tableCustom from '@/views/element-item/tableCustom/index'
import emptyOrErrorStatus from '@/views/element-item/emptyOrErrorStatus'
import myCascader from '@/components/myCascader/index.vue'
import mySelect from '@/components/mySelect/index.vue'
import mySelectSearch from '@/components/mySelectSearch/index.vue'
import myRadio from '@/components/myRadio/index.vue'
import myCheckbox from '@/components/myCheckbox/index.vue'
import myCard from '@/components/myCard/index.vue'
import myTab from '@/components/myTab/index.vue'
import myDescriptions from '@/components/myDescriptions/index.vue'
import myMarkdown from '@/components/myMarkdown/index.vue'
import myImage from '@/components/myImage/index.vue'
import jsUtils from './utils/index'
import jsTool from './utils/jsTool/index'
import comData from './utils/comData/index'
import jsFormRender from './utils/jsFormRender/index'
import { jsTreasurePlaybook, jsTreasureMixin } from 'vue-two-js-tool'
import jsExcel from './utils/jsExcel/index'

import { textDate, textDateOnlyDate } from './utils/filter.js'

import reportBox from '@/components/reportBox/index.vue'

import lodash from 'lodash'
import vuedraggable from 'vuedraggable'
// import XLSX from 'xlsx'
// import XLSXStyle from 'xlsx-js-style'
import moment from 'moment'
// import * as g2plotChart from '@antv/g2plot'
import VueHotkey from 'v-hotkey'
import JsonViewer from 'vue-json-viewer'
import vueTwoJsTool from 'vue-two-js-tool'
import 'vue-two-js-tool/dist/vueTwoJsTool.css'

import mavonEditor from 'mavon-editor'
import 'mavon-editor/dist/css/index.css'

import splitPane from 'vue-splitpane'

import Vant from 'vant'
import 'vant/lib/index.css'

import { mComCustom } from '@/mCom/index'
import datePicker from 'vue2-datepicker'
import 'vue2-datepicker/index.css'
import 'vue2-datepicker/locale/zh-cn'
import componentsUtils from '@/utils/components'

const directiveObj = {}

const dependencies = {
  lodash,
  vuedraggable,
  // XLSX,
  // XLSXStyle,
  moment,
  // g2plotChart,
  VueHotkey
}

import '@/styles/defaultGloabel.scss'
import '@/styles/index.scss'

const comComponents = {
  formGenParser,
  formGenParserItemList,
  myTree,

  formGenRender,
  richEditor,
  richTextRender,

  myCascader,
  mySelect,
  mySelectSearch,
  myRadio,
  myCheckbox,
  myCard,
  myTab,
  myDescriptions,

  searchSelectTag,
  sidebarRouteCom,
  nodeTree,

  reportBox,

  myMarkdown,
  myImage,
  splitPane,
  ...mComCustom
}

const components = {
  tableCustom,

  emptyOrErrorStatus,

  datePicker,
  // fileViewer,
  ...comComponents,
  ...componentsUtils
}

const filterObj = {
  textDate,
  textDateOnlyDate
}

const install = (Vue) => {
  Vue.use(vueTwoJsTool)
  Vue.use(JsonViewer)
  Vue.use(VueHotkey)
  Vue.use(mavonEditor)

  Vue.use(Vant)
  Vue.use(datePicker)
  Object.keys(comComponents).forEach((key) => {
    Vue.component(comComponents[key].name || key, comComponents[key])
  })

  Object.keys(filterObj).forEach((key) => {
    Vue.filter(key, filterObj[key])
  })

  Object.keys(directiveObj).forEach((key) => {
    Vue.directive(directiveObj[key].name, directiveObj[key])
  })
  jsTool.checkPage()
}

if (typeof window !== 'undefined' && window.Vue) {
  install(window.Vue)
}

export default {
  install,
  jsTool,
  jsMixin: jsTreasureMixin,
  comData,
  jsExcel,
  jsUtils,
  jsFormRender,
  jsPlaybook: jsTreasurePlaybook,
  filterObj,
  components,
  dependencies,
  directiveObj
}
