import Vue from 'vue'
import App from './App.vue'
import '@/styles/index.scss'
import '@/styles/defaultGloabel.scss'
import '@/icons/index'
import vueTwoJsTool from 'vue-two-js-tool'
import 'vue-two-js-tool/dist/vueTwoJsTool.css'
import router from './router'
import reportBox from '@/components/reportBox/index.vue'

import myTree from '@/components/myTree/index.vue'
import myCascader from '@/components/myCascader/index.vue'
import myCard from '@/components/myCard/index.vue'
import myTab from '@/components/myTab/index.vue'
import myImage from '@/components/myImage/index.vue'
import myDescriptions from '@/components/myDescriptions/index.vue'
import mySelectSearch from '@/components/mySelectSearch/index.vue'
import mySelect from '@/components/mySelect/index.vue'
import myRadio from '@/components/myRadio/index.vue'
import myCheckbox from '@/components/myCheckbox/index.vue'
import ELEMENT from 'element-ui'
import Vant from 'vant'
import 'vant/lib/index.css'

import 'element-ui/lib/theme-chalk/index.css'
import VueHotkey from 'v-hotkey'

import './bigScreenCom/index'

import myMarkdown from '@/components/myMarkdown/index.vue'
import mavonEditor from 'mavon-editor'
import 'mavon-editor/dist/css/index.css'
import splitPane from 'vue-splitpane'
import tableCustom from '@/views/element-item/tableCustom/index'
import pagination from '@/views/element-item/tableCustom/pagination'

import TableColumn from '@/views/element-item/tableCustom/TableColumn'

import richEditor from '@/views/element-item/richEditor/index'
import richTextRender from '@/views/element-item/richTextRender'
import dataV from '@jiaminghi/data-view'

import '@/mCom/index'

import datePicker from 'vue2-datepicker'
import 'vue2-datepicker/index.css'
import 'vue2-datepicker/locale/zh-cn'

Vue.component('richEditor', richEditor)
Vue.component('richEdit', richEditor)
Vue.component('richTextRender', richTextRender)
Vue.component('pagination', pagination)

Vue.component(TableColumn.name, TableColumn)
Vue.component(tableCustom.name, tableCustom)
Vue.component('split-pane', splitPane)

Vue.component('reportBox', reportBox)
Vue.component('myTree', myTree)
Vue.component('myCascader', myCascader)
Vue.component('myCard', myCard)
Vue.component('myTab', myTab)
Vue.component('myImage', myImage)
Vue.component('myDescriptions', myDescriptions)
Vue.component('mySelect', mySelect)
Vue.component('mySelectSearch', mySelectSearch)
Vue.component('myRadio', myRadio)
Vue.component('myCheckbox', myCheckbox)

Vue.component('myMarkdown', myMarkdown)

Vue.use(ELEMENT)
Vue.use(VueHotkey)
Vue.use(mavonEditor)
Vue.use(dataV)
Vue.use(datePicker)
Vue.use(vueTwoJsTool)

Vue.use(Vant)

window.Vue = Vue

Vue.config.productionTip = false

new Vue({
  router,
  render: (h) => h(App)
}).$mount('#app')
